Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/CodeExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/CodeExpressions.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/CodeExpressions.cs	(revision 15032)
@@ -1,7 +1,5 @@
-﻿/// <summary>
-/// For explicit code manipulation and execution. May also be used as a general list data types.
-/// This types must always be present, as the top level interpreter will push any code to be executed on the
-/// CODE stack prior to execution. However, one may turn off all CODE instructions if code manipulation is not needed.
-/// </summary>
+﻿// For explicit code manipulation and execution. May also be used as a general list data types.
+// This types must always be present, as the top level interpreter will push any code to be executed on the
+// CODE stack prior to execution. However, one may turn off all CODE instructions if code manipulation is not needed.
 
 namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
@@ -18,9 +16,13 @@
 
   /// <summary>
-  ///     Recursively invokes the interpreter on the program on top of the CODE stack. After evaluation the
-  ///     CODE stack is popped; normally this pops the program that was just executed, but if the expression itself
-  ///     manipulates the stack then this final pop may end up popping something else.
-  /// </summary>
-  [PushExpression(StackTypes.Code, "CODE.DO", StackTypes.Exec)]
+  /// Recursively invokes the interpreter on the program on top of the CODE stack. After evaluation the
+  /// CODE stack is popped; normally this pops the program that was just executed, but if the expression itself
+  /// manipulates the stack then this final pop may end up popping something else.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Code,
+    "CODE.DO",
+    "Recursively invokes the interpreter on the program on top of the CODE stack. After evaluation the CODE stack is popped; normally this pops the program that was just executed, but if the expression itself manipulates the stack then this final pop may end up popping something else.",
+    StackTypes.Exec)]
   [StorableClass]
   public class CodeDoExpression : StatelessExpression {
@@ -40,7 +42,11 @@
 
   /// <summary>
-  ///     Like CODE.DO but pops the stack before, rather than after, the recursive execution
-  /// </summary>
-  [PushExpression(StackTypes.Code, "CODE.DO*", StackTypes.Exec)]
+  /// Like CODE.DO but pops the stack before, rather than after, the recursive execution.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Code,
+    "CODE.DO*",
+    "Like CODE.DO but pops the stack before, rather than after, the recursive execution.",
+    StackTypes.Exec)]
   [StorableClass]
   public class CodeDoXExpression : StatelessExpression {
@@ -62,5 +68,8 @@
   ///     Does nothing.
   /// </summary>
-  [PushExpression(StackTypes.Code, "CODE.NOOP")]
+  [PushExpression(
+    StackTypes.Code,
+    "CODE.NOOP",
+    "Does nothing.")]
   [StorableClass]
   public class CodeNoopExpression : StatelessExpression {
@@ -79,8 +88,11 @@
 
   /// <summary>
-  ///     Specifies that the next expression submitted for execution will instead be pushed literally onto the CODE stack.
-  ///     This can be implemented by moving the top item on the EXEC stack onto the CODE stack.
-  /// </summary>
-  [PushExpression(StackTypes.Code, "CODE.QUOTE", StackTypes.Exec)]
+  /// Specifies that the next expression submitted for execution will instead be pushed literally onto the CODE stack.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Code,
+    "CODE.QUOTE",
+    "Specifies that the next expression submitted for execution will instead be pushed literally onto the CODE stack.",
+    StackTypes.Exec)]
   [StorableClass]
   public class CodeQuoteExpression : StatelessExpression {
@@ -100,9 +112,13 @@
 
   /// <summary>
-  ///     If the top item of the BOOLEAN stack is TRUE this recursively executes the second item of the CODE stack;
-  ///     otherwise it recursively executes the first item of the CODE stack. Either way both elements of the CODE stack
-  ///     (and the BOOLEAN value upon which the decision was made) are popped.
-  /// </summary>
-  [PushExpression(StackTypes.Code, "CODE.IF", StackTypes.Exec | StackTypes.Boolean)]
+  /// If the top item of the BOOLEAN stack is TRUE this recursively executes the second item of the CODE stack;
+  /// otherwise it recursively executes the first item of the CODE stack. Either way both elements of the CODE stack
+  /// (and the BOOLEAN value upon which the decision was made) are popped.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Code,
+    "CODE.IF",
+    "If the top item of the BOOLEAN stack is TRUE this recursively executes the second item of the CODE stack, otherwise it recursively executes the first item of the CODE stack",
+    StackTypes.Exec | StackTypes.Boolean)]
   [StorableClass]
   public class CodeIfExpression : StatelessExpression {
@@ -126,8 +142,11 @@
 
   /// <summary>
-  ///     Pushes the result of appending the top two pieces of code. If one of the pieces of code is a single instruction or
-  ///     literal (that is, something not surrounded by parentheses) then it is surrounded by parentheses first.
-  /// </summary>
-  [PushExpression(StackTypes.Code, "CODE.APPEND")]
+  /// Pushes the result of appending the top two pieces of code. If one of the pieces of code is a single instruction or
+  /// literal (that is, something not surrounded by parentheses) then it is surrounded by parentheses first.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Code,
+    "CODE.APPEND",
+    "Pushes the result of appending the top two pieces of code.")]
   [StorableClass]
   public class CodeAppendExpression : StatelessExpression {
@@ -191,8 +210,12 @@
 
   /// <summary>
-  ///     Pushes TRUE onto the BOOLEAN stack if the top piece of code is a single instruction or a literal,
-  ///     and FALSE otherwise (that is, if it is something surrounded by parentheses).
-  /// </summary>
-  [PushExpression(StackTypes.Code, "CODE.ATOM", StackTypes.Boolean)]
+  /// Pushes TRUE onto the BOOLEAN stack if the top piece of code is a single instruction or a literal,
+  /// and FALSE otherwise (that is, if it is something surrounded by parentheses).
+  /// </summary>
+  [PushExpression(
+    StackTypes.Code,
+    "CODE.ATOM",
+    "Pushes TRUE onto the BOOLEAN stack if the top piece of code is a single instruction or a literal, and FALSE otherwise",
+    StackTypes.Boolean)]
   [StorableClass]
   public class CodeAtomExpression : StatelessExpression {
@@ -214,10 +237,9 @@
 
   /// <summary>
-  ///     Pushes the first item of the list on top of the CODE stack. For example, if the top piece of code is "( A B )"
-  ///     then this pushes "A" (after popping the argument). If the code on top of the stack is not a list then this has no
-  ///     effect.
-  ///     The name derives from the similar Lisp function; a more generic name would be "FIRST".
-  /// </summary>
-  [PushExpression(StackTypes.Code, "CODE.CAR")]
+  /// Pushes the first item of the list on top of the CODE stack. For example, if the top piece of code is "( A B )"
+  /// then this pushes "A" (after popping the argument). If the code on top of the stack is not a list then this has no
+  /// effect. The name derives from the similar Lisp function; a more generic name would be "FIRST".
+  /// </summary>
+  [PushExpression(StackTypes.Code, "CODE.CAR", "Pushes the first item of the list on top of the CODE stack.")]
   [StorableClass]
   public class CodeCarExpression : StatelessExpression {
@@ -241,10 +263,13 @@
 
   /// <summary>
-  ///     Pushes a version of the list from the top of the CODE stack without its first element.
-  ///     For example, if the top piece of code is "( A B )" then this pushes "( B )" (after popping the argument).
-  ///     If the code on top of the stack is not a list then this pushes the empty list ("( )"). The name derives from
-  ///     the similar Lisp function; a more generic name would be "REST".
-  /// </summary>
-  [PushExpression(StackTypes.Code, "CODE.CDR")]
+  /// Pushes a version of the list from the top of the CODE stack without its first element.
+  /// For example, if the top piece of code is "( A B )" then this pushes "( B )" (after popping the argument).
+  /// If the code on top of the stack is not a list then this pushes the empty list ("( )"). The name derives from
+  /// the similar Lisp function; a more generic name would be "REST".
+  /// </summary>
+  [PushExpression(
+    StackTypes.Code,
+    "CODE.CDR",
+    "Pushes a version of the list from the top of the CODE stack without its first element.")]
   [StorableClass]
   public class CodeCdrExpression : StatelessExpression {
@@ -276,9 +301,12 @@
 
   /// <summary>
-  ///     Pushes the result of "consing" (in the Lisp sense) the second stack item onto the first stack item
-  ///     (which is coerced to a list if necessary). For example, if the top piece of code is "( A B )" and the
-  ///     second piece of code is "X" then this pushes "( X A B )" (after popping the argument).
-  /// </summary>
-  [PushExpression(StackTypes.Code, "CODE.CONS")]
+  /// Pushes the result of "consing" (in the Lisp sense) the second stack item onto the first stack item
+  /// (which is coerced to a list if necessary). For example, if the top piece of code is "( A B )" and the
+  /// second piece of code is "X" then this pushes "( X A B )" (after popping the argument).
+  /// </summary>
+  [PushExpression(
+    StackTypes.Code,
+    "CODE.CONS",
+    "Pushes the result of \"consing\" (in the Lisp sense) the second stack item onto the first stack item.")]
   [StorableClass]
   public class CodeConsExpression : StatelessExpression {
@@ -310,12 +338,14 @@
 
   /// <summary>
-  ///     Pushes the "container" of the second CODE stack item within the first CODE stack item onto the CODE stack.
-  ///     If second item contains the first anywhere (i.e. in any nested list) then the container is the smallest sub-list
-  ///     that contains but is not equal to the first instance. For example, if the top piece of code is "( B ( C ( A ) ) ( D
-  ///     ( A ) ) )"
-  ///     and the second piece of code is "( A )" then this pushes ( C ( A ) ). Pushes an empty list if there is no such
-  ///     container.
-  /// </summary>
-  [PushExpression(StackTypes.Code, "CODE.CONTAINER")]
+  /// Pushes the "container" of the second CODE stack item within the first CODE stack item onto the CODE stack.
+  /// If second item contains the first anywhere (i.e. in any nested list) then the container is the smallest sub-list
+  /// that contains but is not equal to the first instance. For example, if the top piece of code is "( B ( C ( A ) ) ( D
+  /// ( A ) ) )" and the second piece of code is "( A )" then this pushes ( C ( A ) ). Pushes an empty list if there is no such
+  /// container.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Code,
+    "CODE.CONTAINER",
+    "Pushes the \"container\" of the second CODE stack item within the first CODE stack item onto the CODE stack")]
   [StorableClass]
   public class CodeContainerExpression : StatelessExpression {
@@ -358,8 +388,12 @@
 
   /// <summary>
-  ///     Pushes TRUE on the BOOLEAN stack if the second CODE stack item contains the first CODE stack
-  ///     item anywhere (e.g. in a sub-list).
-  /// </summary>
-  [PushExpression(StackTypes.Code, "CODE.CONTAINS", StackTypes.Boolean)]
+  /// Pushes TRUE on the BOOLEAN stack if the second CODE stack item contains the first CODE stack
+  /// item anywhere (e.g. in a sub-list).
+  /// </summary>
+  [PushExpression(
+    StackTypes.Code,
+    "CODE.CONTAINS",
+    "Pushes TRUE on the BOOLEAN stack if the second CODE stack item contains the first CODE stack item anywhere.",
+    StackTypes.Boolean)]
   [StorableClass]
   public class CodeContainsExpression : StatelessExpression {
@@ -383,9 +417,13 @@
 
   /// <summary>
-  ///     Pushes the definition associated with the top NAME on the NAME stack (if any) onto the CODE stack.
-  ///     This extracts the definition for inspection/manipulation, rather than for immediate execution (although it
-  ///     may then be executed with a call to CODE.DO or a similar instruction).
-  /// </summary>
-  [PushExpression(StackTypes.Code, "CODE.DEFINITION", StackTypes.Name)]
+  /// Pushes the definition associated with the top NAME on the NAME stack (if any) onto the CODE stack.
+  /// This extracts the definition for inspection/manipulation, rather than for immediate execution (although it
+  /// may then be executed with a call to CODE.DO or a similar instruction).
+  /// </summary>
+  [PushExpression(
+    StackTypes.Code,
+    "CODE.DEFINITION",
+    "Pushes the definition associated with the top NAME on the NAME stack (if any) onto the CODE stack.",
+    StackTypes.Name)]
   [StorableClass]
   public class CodeDefinitionExpression : StatelessExpression {
@@ -432,5 +470,9 @@
   ///     </list>
   /// </summary>
-  [PushExpression(StackTypes.Code, "CODE.DISCREPANCY", StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.Code,
+    "CODE.DISCREPANCY",
+    "Pushes a measure of the discrepancy between the top two CODE stack items onto the INTEGER stack",
+    StackTypes.Integer)]
   [StorableClass]
   public class CodeDiscrepancyExpression : StatelessExpression {
@@ -488,14 +530,15 @@
 
   /// <summary>
-  ///     Pushes the sub-expression of the top item of the CODE stack that is indexed by the top item of the INTEGER stack.
-  ///     The indexing here counts "points," where each parenthesized expression and each literal/instruction is considered a
-  ///     point,
-  ///     and it proceeds in depth first order. The entire piece of code is at index 0; if it is a list then the first item
-  ///     in the list
-  ///     is at index 1, etc. The integer used as the index is taken modulo the number of points in the overall expression
-  ///     (and its
-  ///     absolute value is taken in case it is negative) to ensure that it is within the meaningful range.
-  /// </summary>
-  [PushExpression(StackTypes.Code, "CODE.EXTRACT", StackTypes.Integer)]
+  /// Pushes the sub-expression of the top item of the CODE stack that is indexed by the top item of the INTEGER stack.
+  /// The indexing here counts "points," where each parenthesized expression and each literal/instruction is considered a
+  /// point, and it proceeds in depth first order. The entire piece of code is at index 0; if it is a list then the first item
+  /// in the list is at index 1, etc. The integer used as the index is taken modulo the number of points in the overall expression
+  /// (and its absolute value is taken in case it is negative) to ensure that it is within the meaningful range.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Code,
+    "CODE.EXTRACT",
+    "Pushes the sub-expression of the top item of the CODE stack that is indexed by the top item of the INTEGER stack.",
+    StackTypes.Integer)]
   [StorableClass]
   public class CodeExtractExpression : StatelessExpression {
@@ -520,7 +563,11 @@
 
   /// <summary>
-  ///     Pops the BOOLEAN stack and pushes the popped item (TRUE or FALSE) onto the CODE stack.
-  /// </summary>
-  [PushExpression(StackTypes.Code, "CODE.FROMBOOLEAN", StackTypes.Boolean)]
+  /// Pops the BOOLEAN stack and pushes the popped item (TRUE or FALSE) onto the CODE stack.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Code,
+    "CODE.FROMBOOLEAN",
+    "Pops the BOOLEAN stack and pushes the popped item(TRUE or FALSE) onto the CODE stack.",
+    StackTypes.Boolean)]
   [StorableClass]
   public class CodeFromBooleanExpression : StatelessExpression {
@@ -543,7 +590,11 @@
 
   /// <summary>
-  ///     Pops the FLOAT stack and pushes the popped item onto the CODE stack.
-  /// </summary>
-  [PushExpression(StackTypes.Code, "CODE.FROMFLOAT", StackTypes.Float)]
+  /// Pops the FLOAT stack and pushes the popped item onto the CODE stack.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Code,
+    "CODE.FROMFLOAT",
+    "Pops the FLOAT stack and pushes the popped item onto the CODE stack.",
+    StackTypes.Float)]
   [StorableClass]
   public class CodeFromFloatExpression : StatelessExpression {
@@ -566,7 +617,11 @@
 
   /// <summary>
-  ///     Pops the INTEGER stack and pushes the popped integer onto the CODE stack.
-  /// </summary>
-  [PushExpression(StackTypes.Code, "CODE.FROMINTEGER", StackTypes.Integer)]
+  /// Pops the INTEGER stack and pushes the popped integer onto the CODE stack.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Code,
+    "CODE.FROMINTEGER",
+    "Pops the INTEGER stack and pushes the popped integer onto the CODE stack.",
+    StackTypes.Integer)]
   [StorableClass]
   public class CodeFromIntegerExpression : StatelessExpression {
@@ -589,7 +644,11 @@
 
   /// <summary>
-  ///     Pops the NAME stack and pushes the popped item onto the CODE stack.
-  /// </summary>
-  [PushExpression(StackTypes.Code, "CODE.FROMNAME", StackTypes.Name)]
+  /// Pops the NAME stack and pushes the popped item onto the CODE stack.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Code,
+    "CODE.FROMNAME",
+    "Pops the NAME stack and pushes the popped item onto the CODE stack.",
+    StackTypes.Name)]
   [StorableClass]
   public class CodeFromNameExpression : StatelessExpression {
@@ -611,8 +670,12 @@
 
   /// <summary>
-  ///     Pushes the result of inserting the second item of the CODE stack into the first item, at the position indexed
-  ///     by the top item of the INTEGER stack (and replacing whatever was there formerly).
-  /// </summary>
-  [PushExpression(StackTypes.Code, "CODE.CODEINSERT", StackTypes.Integer)]
+  /// Pushes the result of inserting the second item of the CODE stack into the first item, at the position indexed
+  /// by the top item of the INTEGER stack (and replacing whatever was there formerly).
+  /// </summary>
+  [PushExpression(
+    StackTypes.Code,
+    "CODE.CODEINSERT",
+    "Pushes the result of inserting the second item of the CODE stack into the first item, at the position indexed by the top item of the INTEGER stack.",
+    StackTypes.Integer)]
   [StorableClass]
   public class CodeInsertExpression : StatelessExpression {
@@ -651,10 +714,14 @@
 
   /// <summary>
-  ///     Pushes the length of the top item on the CODE stack onto the INTEGER stack.
-  ///     If the top item is not a list then this pushes a 1. If the top item is a list then this pushes the
-  ///     number of items in the top level of the list; that is, nested lists contribute only 1 to this count, no
-  ///     matter what they contain.
-  /// </summary>
-  [PushExpression(StackTypes.Code, "CODE.LENGTH", StackTypes.Integer)]
+  /// Pushes the length of the top item on the CODE stack onto the INTEGER stack.
+  /// If the top item is not a list then this pushes a 1. If the top item is a list then this pushes the
+  /// number of items in the top level of the list; that is, nested lists contribute only 1 to this count, no
+  /// matter what they contain.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Code,
+    "CODE.LENGTH",
+    "Pushes the length of the top item on the CODE stack onto the INTEGER stack.",
+    StackTypes.Integer)]
   [StorableClass]
   public class CodeLengthExpression : StatelessExpression {
@@ -679,7 +746,10 @@
 
   /// <summary>
-  ///     Pushes a list of the top two items of the CODE stack onto the CODE stack.
-  /// </summary>
-  [PushExpression(StackTypes.Code, "CODE.LIST")]
+  /// Pushes a list of the top two items of the CODE stack onto the CODE stack.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Code,
+    "CODE.LIST",
+    "Pushes a list of the top two items of the CODE stack onto the CODE stack.")]
   [StorableClass]
   public class CodeListExpression : StatelessExpression {
@@ -708,8 +778,12 @@
 
   /// <summary>
-  ///     Pushes TRUE onto the BOOLEAN stack if the second item of the CODE stack is a member of the first item
-  ///     (which is coerced to a list if necessary). Pushes FALSE onto the BOOLEAN stack otherwise.
-  /// </summary>
-  [PushExpression(StackTypes.Code, "CODE.MEMBER", StackTypes.Boolean)]
+  /// Pushes TRUE onto the BOOLEAN stack if the second item of the CODE stack is a member of the first item
+  /// (which is coerced to a list if necessary). Pushes FALSE onto the BOOLEAN stack otherwise.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Code,
+    "CODE.MEMBER",
+    "Pushes TRUE onto the BOOLEAN stack if the second item of the CODE stack is a member of the first item, FALSE otherwise.",
+    StackTypes.Boolean)]
   [StorableClass]
   public class CodeMemberExpression : StatelessExpression {
@@ -736,9 +810,13 @@
 
   /// <summary>
-  ///     Pushes the nth element of the expression on top of the CODE stack (which is coerced to a list first if necessary).
-  ///     If the expression is an empty list then the result is an empty list. N is taken from the INTEGER stack and is taken
-  ///     modulo the length of the expression into which it is indexing.
-  /// </summary>
-  [PushExpression(StackTypes.Code, "CODE.NTH", StackTypes.Integer)]
+  /// Pushes the nth element of the expression on top of the CODE stack (which is coerced to a list first if necessary).
+  /// If the expression is an empty list then the result is an empty list. N is taken from the INTEGER stack and is taken
+  /// modulo the length of the expression into which it is indexing.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Code,
+    "CODE.NTH",
+    "Pushes the nth element, whereby n is taken from the INTEGER stack, of the expression on top of the CODE stack.",
+    StackTypes.Integer)]
   [StorableClass]
   public class CodeNthExpression : StatelessExpression {
@@ -776,12 +854,14 @@
 
   /// <summary>
-  ///     Pushes the nth "CDR" (in the Lisp sense) of the expression on top of the CODE stack (which is coerced to a list
-  ///     first if necessary). If the expression is an empty list then the result is an empty list. N is taken from the
-  ///     INTEGER
-  ///     stack and is taken modulo the length of the expression into which it is indexing. A "CDR" of a list is the list
-  ///     without
-  ///     its first element.
-  /// </summary>
-  [PushExpression(StackTypes.Code, "CODE.NTHCDR", StackTypes.Integer)]
+  /// Pushes the nth "CDR" (in the Lisp sense) of the expression on top of the CODE stack (which is coerced to a list
+  /// first if necessary). If the expression is an empty list then the result is an empty list. N is taken from the
+  /// INTEGER stack and is taken modulo the length of the expression into which it is indexing. A "CDR" of a list is the list
+  /// without its first element.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Code,
+    "CODE.NTHCDR",
+    "Pushes the nth \"CDR\" (in the Lisp sense) of the expression on top of the CODE stack, whereby n is taken from the INTEGER stack.",
+    StackTypes.Integer)]
   [StorableClass]
   public class CodeNthCdrExpression : StatelessExpression {
@@ -819,7 +899,11 @@
 
   /// <summary>
-  ///     Pushes TRUE onto the BOOLEAN stack if the top item of the CODE stack is an empty list, or FALSE otherwise.
-  /// </summary>
-  [PushExpression(StackTypes.Code, "CODE.NULL", StackTypes.Boolean)]
+  /// Pushes TRUE onto the BOOLEAN stack if the top item of the CODE stack is an empty list, or FALSE otherwise.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Code,
+    "CODE.NULL",
+    "Pushes TRUE onto the BOOLEAN stack if the top item of the CODE stack is an empty list, or FALSE otherwise",
+    StackTypes.Boolean)]
   [StorableClass]
   public class CodeNullExpression : StatelessExpression {
@@ -840,8 +924,12 @@
 
   /// <summary>
-  ///     Pushes onto the INTEGER stack the position of the second item on the CODE stack within the first item
-  ///     (which is coerced to a list if necessary). Pushes -1 if no match is found.
-  /// </summary>
-  [PushExpression(StackTypes.Code, "CODE.POSITION", StackTypes.Integer)]
+  /// Pushes onto the INTEGER stack the position of the second item on the CODE stack within the first item
+  /// (which is coerced to a list if necessary). Pushes -1 if no match is found.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Code,
+    "CODE.POSITION",
+    "Pushes onto the INTEGER stack the position of the second item on the CODE stack within the first item. Pushes -1 if no match is found",
+    StackTypes.Integer)]
   [StorableClass]
   public class CodePositionExpression : StatelessExpression {
@@ -872,8 +960,12 @@
 
   /// <summary>
-  ///     Pushes the number of "points" in the top piece of CODE onto the INTEGER stack. Each instruction, literal,
-  ///     and pair of parentheses counts as a point.
-  /// </summary>
-  [PushExpression(StackTypes.Code, "CODE.SIZE", StackTypes.Integer)]
+  /// Pushes the number of "points" in the top piece of CODE onto the INTEGER stack. Each instruction, literal,
+  /// and pair of parentheses counts as a point.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Code,
+    "CODE.SIZE",
+    "Pushes the number of \"points\" in the top piece of CODE onto the INTEGER stack. Each instruction, literal, and pair of parentheses counts as a point.",
+    StackTypes.Integer)]
   [StorableClass]
   public class CodeSizeExpression : StatelessExpression {
@@ -897,10 +989,13 @@
 
   /// <summary>
-  ///     Pushes the result of substituting the third item on the code stack for the second item in the first item.
-  ///     As of this writing this is implemented only in the Lisp implementation, within which it relies on the Lisp "subst"
-  ///     function. As such, there are several problematic possibilities; for example "dotted-lists" can result in certain
-  ///     cases with empty-list arguments. If any of these problematic possibilities occurs the stack is left unchanged.
-  /// </summary>
-  [PushExpression(StackTypes.Code, "CODE.SUBST")]
+  /// Pushes the result of substituting the third item on the code stack for the second item in the first item.
+  /// As of this writing this is implemented only in the Lisp implementation, within which it relies on the Lisp "subst"
+  /// function. As such, there are several problematic possibilities; for example "dotted-lists" can result in certain
+  /// cases with empty-list arguments. If any of these problematic possibilities occurs the stack is left unchanged.
+  /// </summary>
+  [PushExpression(
+    StackTypes.Code,
+    "CODE.SUBST",
+    "Pushes the result of substituting the third item on the code stack for the second item in the first item.")]
   [StorableClass]
   public class CodeSubstitutionExpression : StatelessExpression {
